diff --git a/contrib/gmm/gmm_inoutput.h b/contrib/gmm/gmm_inoutput.h
index b6f907a2e4..9bb51713ee 100644
--- a/contrib/gmm/gmm_inoutput.h
+++ b/contrib/gmm/gmm_inoutput.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2003-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2003-2020 Yves Renard, Julien Pommier
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_inoutput.h
    @author Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -50,10 +51,10 @@ namespace gmm {
   /*************************************************************************/
 
   // Fri Aug 15 16:29:47 EDT 1997
-  //
+  // 
   //                      Harwell-Boeing File I/O in C
   //                               V. 1.0
-  //
+  // 
   //          National Institute of Standards and Technology, MD.
   //                            K.A. Remington
   // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -66,8 +67,8 @@ namespace gmm {
   // supporting documentation.
   //
   // Neither the Author nor the Institution (National Institute of Standards
-  // and Technology) make any representations about the suitability of this
-  // software for any purpose. This software is provided "as is" without
+  // and Technology) make any representations about the suitability of this 
+  // software for any purpose. This software is provided "as is" without 
   // expressed or implied warranty.
   // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
@@ -84,7 +85,7 @@ namespace gmm {
     }
     return *width;
   }
-
+  
   inline int ParseRfmt(const char *fmt, int* perline, int* width,
 		       int* prec, int* flag) {
     char p;
@@ -108,7 +109,7 @@ namespace gmm {
     *flag = p;
     return *width;
   }
-
+      
   /** matrix input/output for Harwell-Boeing format */
   struct HarwellBoeing_IO {
     int nrows() const { return Nrow; }
@@ -123,17 +124,17 @@ namespace gmm {
     /** open filename and reads header */
     void open(const char *filename);
     /** read the opened file */
-    template <typename T, int shift> void read(csc_matrix<T, shift>& A);
+    template <typename T, typename IND_TYPE, int shift> void read(csc_matrix<T, IND_TYPE, shift>& A);
     template <typename MAT> void read(MAT &M) IS_DEPRECATED;
-    template <typename T, int shift>
-    static void write(const char *filename, const csc_matrix<T, shift>& A);
-    template <typename T, int shift>
-    static void write(const char *filename, const csc_matrix<T, shift>& A,
+    template <typename T, typename IND_TYPE, int shift>
+    static void write(const char *filename, const csc_matrix<T, IND_TYPE, shift>& A);
+    template <typename T, typename IND_TYPE, int shift>
+    static void write(const char *filename, const csc_matrix<T, IND_TYPE, shift>& A,
 		      const std::vector<T> &rhs);
-    template <typename T, typename INDI, typename INDJ, int shift>
+    template <typename T, typename INDI, typename INDJ, int shift> 
     static void write(const char *filename,
 		      const csc_matrix_ref<T*, INDI*, INDJ*, shift>& A);
-    template <typename T, typename INDI, typename INDJ, int shift>
+    template <typename T, typename INDI, typename INDJ, int shift> 
     static void write(const char *filename,
 		      const csc_matrix_ref<T*, INDI*, INDJ*, shift>& A,
 		      const std::vector<T> &rhs);
@@ -146,21 +147,22 @@ namespace gmm {
     char Title[73], Key[9], Rhstype[4], Type[4];
     int Nrow, Ncol, Nnzero, Nrhs;
     char Ptrfmt[17], Indfmt[17], Valfmt[21], Rhsfmt[21];
-    int Ptrcrd, Indcrd, Valcrd, Rhscrd;
+    int Ptrcrd, Indcrd, Valcrd, Rhscrd; 
     int lcount;
 
 
     void close() { if (f) fclose(f); clear(); }
-    void clear() {
+    void clear() { 
       Nrow = Ncol = Nnzero = Nrhs = 0; f = 0; lcount = 0;
-      memset(Type, 0, sizeof Type);
-      memset(Key, 0, sizeof Key);
-      memset(Title, 0, sizeof Title);
+      memset(Type, 0, sizeof Type); 
+      memset(Key, 0, sizeof Key); 
+      memset(Title, 0, sizeof Title); 
     }
-    char *getline(char *buf) {
-      if(fgets(buf, BUFSIZ, f) == NULL) return buf; ++lcount;
+    char *getline(char *buf) { 
+      char *p = fgets(buf, BUFSIZ, f); ++lcount;
       int s = SECURE_NONCHAR_SSCANF(buf,"%*s");
-      GMM_ASSERT1(s >= 0, "blank line in HB file at line " << lcount);
+      GMM_ASSERT1(s >= 0 && p != 0,
+		  "blank line in HB file at line " << lcount);
       return buf;
     }
 
@@ -173,19 +175,19 @@ namespace gmm {
       SECURE_STRNCPY(s, 100, p, len); s[len] = 0;
       if ( Valflag != 'F' && !strchr(s,'E')) {
 	/* insert a char prefix for exp */
-	int last = strlen(s);
+	int last = int(strlen(s));
 	for (int j=last+1;j>=0;j--) {
 	  s[j] = s[j-1];
 	  if ( s[j] == '+' || s[j] == '-' ) {
-	    s[j-1] = Valflag;
+	    s[j-1] = char(Valflag);                    
 	    break;
 	  }
 	}
       }
       return atof(s);
     }
-    template <typename IND_TYPE>
-    int readHB_data(IND_TYPE colptr[], IND_TYPE rowind[],
+    template <typename IND_TYPE>   
+    int readHB_data(IND_TYPE colptr[], IND_TYPE rowind[], 
 		    double val[]) {
       /***********************************************************************/
       /*  This function opens and reads the specified file, interpreting its */
@@ -208,8 +210,10 @@ namespace gmm {
       int i,ind,col,offset,count;
       int Ptrperline, Ptrwidth, Indperline, Indwidth;
       int Valperline, Valwidth, Valprec, Nentries;
-      int Valflag;           /* Indicates 'E','D', or 'F' float format */
+      int Valflag = 'D';           /* Indicates 'E','D', or 'F' float format */
       char line[BUFSIZ];
+      gmm::standard_locale sl;
+
 
       /*  Parse the array input formats from Line 3 of HB file  */
       ParseIfmt(Ptrfmt,&Ptrperline,&Ptrwidth);
@@ -217,13 +221,11 @@ namespace gmm {
       if ( Type[0] != 'P' ) {          /* Skip if pattern only  */
 	ParseRfmt(Valfmt,&Valperline,&Valwidth,&Valprec,&Valflag);
       }
-
-      cout << "Valwidth = " << Valwidth << endl; getchar();
-
+    
       /*  Read column pointer array:   */
       offset = 0;         /* if base 0 storage is declared (via macro def),  */
       /* then storage entries are offset by 1            */
-
+    
       for (count = 0, i=0;i<Ptrcrd;i++) {
 	getline(line);
 	for (col = 0, ind = 0;ind<Ptrperline;ind++) {
@@ -232,8 +234,8 @@ namespace gmm {
 	  count++; col += Ptrwidth;
 	}
       }
-
-      /*  Read row index array:  */
+    
+      /*  Read row index array:  */    
       for (count = 0, i=0;i<Indcrd;i++) {
 	getline(line);
 	for (col = 0, ind = 0;ind<Indperline;ind++) {
@@ -242,12 +244,12 @@ namespace gmm {
 	  count++; col += Indwidth;
 	}
       }
-
+    
       /*  Read array of values:  */
       if ( Type[0] != 'P' ) {          /* Skip if pattern only  */
 	if ( Type[0] == 'C' ) Nentries = 2*Nnzero;
 	else Nentries = Nnzero;
-
+      
 	count = 0;
 	for (i=0;i<Valcrd;i++) {
 	  getline(line);
@@ -266,7 +268,7 @@ namespace gmm {
       return 1;
     }
   };
-
+  
   inline void HarwellBoeing_IO::open(const char *filename) {
     int Totcrd,Neltvl,Nrhsix;
     char line[BUFSIZ];
@@ -284,7 +286,7 @@ namespace gmm {
     Totcrd = Ptrcrd = Indcrd = Valcrd = Rhscrd = 0;
     SECURE_NONCHAR_SSCANF(getline(line), "%d%d%d%d%d", &Totcrd, &Ptrcrd,
 			  &Indcrd, &Valcrd, &Rhscrd);
-
+    
     /* Third line: */
     Nrow = Ncol = Nnzero = Neltvl = 0;
 #ifdef GMM_SECURE_CRT
@@ -295,8 +297,8 @@ namespace gmm {
 	       &Neltvl) < 1)
 #endif
       IOHBTerminate("Invalid Type info, line 3 of Harwell-Boeing file.\n");
-    for (size_type i = 0; i < 3; ++i) Type[i] = toupper(Type[i]);
-
+    for (size_type i = 0; i < 3; ++i) Type[i] = char(toupper(Type[i]));
+    
       /*  Fourth line:  */
 #ifdef GMM_SECURE_CRT
     if ( sscanf_s(getline(line), "%c%c%c%c",Ptrfmt, 16,Indfmt, 16,Valfmt,
@@ -305,11 +307,11 @@ namespace gmm {
     if ( sscanf(getline(line), "%16c%16c%20c%20c",Ptrfmt,Indfmt,Valfmt,
 		Rhsfmt) < 3)
 #endif
-      IOHBTerminate("Invalid format info, line 4 of Harwell-Boeing file.\n");
+      IOHBTerminate("Invalid format info, line 4 of Harwell-Boeing file.\n"); 
     Ptrfmt[16] = Indfmt[16] = Valfmt[20] = Rhsfmt[20] = 0;
-
+    
     /*  (Optional) Fifth line: */
-    if (Rhscrd != 0 ) {
+    if (Rhscrd != 0 ) { 
       Nrhs = Nrhsix = 0;
 #ifdef GMM_SECURE_CRT
       if ( sscanf_s(getline(line), "%c%d%d", Rhstype, 3, &Nrhs, &Nrhsix) != 1)
@@ -322,10 +324,10 @@ namespace gmm {
   }
 
   /* only valid for double and complex<double> csc matrices */
-  template <typename T, int shift> void
-  HarwellBoeing_IO::read(csc_matrix<T, shift>& A) {
+  template <typename T, typename IND_TYPE, int shift> void
+  HarwellBoeing_IO::read(csc_matrix<T, IND_TYPE, shift>& A) {
 
-    typedef typename csc_matrix<T, shift>::IND_TYPE IND_TYPE;
+    // typedef typename csc_matrix<T, shift>::IND_TYPE IND_TYPE;
 
     GMM_ASSERT1(f, "no file opened!");
     GMM_ASSERT1(Type[0] != 'P',
@@ -334,33 +336,31 @@ namespace gmm {
 		"Bad HB matrix format (file contains a REAL matrix)");
     GMM_ASSERT1(is_complex_double__(T()) || Type[0] != 'C',
 		"Bad HB matrix format (file contains a COMPLEX matrix)");
-    if (A.pr) { delete[] A.pr; delete[] A.ir; delete[] A.jc; }
     A.nc = ncols(); A.nr = nrows();
-    A.pr = 0;
-    A.jc = new IND_TYPE[ncols()+1];
-    A.ir = new IND_TYPE[nnz()];
-    A.pr = new T[nnz()];
-    readHB_data(A.jc, A.ir, (double*)A.pr);
+    A.jc.resize(ncols()+1);
+    A.ir.resize(nnz());
+    A.pr.resize(nnz());
+    readHB_data(&A.jc[0], &A.ir[0], (double*)&A.pr[0]);
     for (int i = 0; i <= ncols(); ++i) { A.jc[i] += shift; A.jc[i] -= 1; }
     for (int i = 0; i < nnz(); ++i)    { A.ir[i] += shift; A.ir[i] -= 1; }
   }
 
-  template <typename MAT> void
+  template <typename MAT> void 
   HarwellBoeing_IO::read(MAT &M) {
     csc_matrix<typename gmm::linalg_traits<MAT>::value_type> csc;
-    read(csc);
+    read(csc); 
     resize(M, mat_nrows(csc), mat_ncols(csc));
     copy(csc, M);
   }
-
-  template <typename IND_TYPE>
+  
+  template <typename IND_TYPE> 
   inline int writeHB_mat_double(const char* filename, int M, int N, int nz,
 				const IND_TYPE colptr[],
-				const IND_TYPE rowind[],
+				const IND_TYPE rowind[], 
 				const double val[], int Nrhs,
 				const double rhs[], const double guess[],
 				const double exact[], const char* Title,
-				const char* Key, const char* Type,
+				const char* Key, const char* Type, 
 				const char* Ptrfmt, const char* Indfmt,
 				const char* Valfmt, const char* Rhsfmt,
 				const char* Rhstype, int shift) {
@@ -382,34 +382,38 @@ namespace gmm {
     int Valperline, Valwidth, Valprec;
     int Valflag;           /* Indicates 'E','D', or 'F' float format */
     char pformat[16],iformat[16],vformat[19],rformat[19];
-
+    //    char *pValflag, *pRhsflag;
+    gmm::standard_locale sl;
+    
     if ( Type[0] == 'C' )
       { nvalentries = 2*nz; nrhsentries = 2*M; }
     else
       { nvalentries = nz; nrhsentries = M; }
-
+    
     if ( filename != NULL ) {
       SECURE_FOPEN(&out_file, filename, "w");
       GMM_ASSERT1(out_file != NULL, "Error: Cannot open file: " << filename);
     } else out_file = stdout;
-
+    
     if ( Ptrfmt == NULL ) Ptrfmt = "(8I10)";
     ParseIfmt(Ptrfmt, &Ptrperline, &Ptrwidth);
     SECURE_SPRINTF1(pformat,sizeof(pformat),"%%%dd",Ptrwidth);
     ptrcrd = (N+1)/Ptrperline;
     if ( (N+1)%Ptrperline != 0) ptrcrd++;
-
+    
     if ( Indfmt == NULL ) Indfmt =  Ptrfmt;
     ParseIfmt(Indfmt, &Indperline, &Indwidth);
     SECURE_SPRINTF1(iformat,sizeof(iformat), "%%%dd",Indwidth);
     indcrd = nz/Indperline;
     if ( nz%Indperline != 0) indcrd++;
-
+    
     if ( Type[0] != 'P' ) {          /* Skip if pattern only  */
       if ( Valfmt == NULL ) Valfmt = "(4E21.13)";
       ParseRfmt(Valfmt, &Valperline, &Valwidth, &Valprec, &Valflag);
-      //Gmsh fix: this is invalid, as Valfmt is a const char*
-      //if (Valflag == 'D') *strchr(Valfmt,'D') = 'E';
+//       if (Valflag == 'D') {
+//         pValflag = (char *) strchr(Valfmt,'D');
+//         *pValflag = 'E';
+//       }
       if (Valflag == 'F')
 	SECURE_SPRINTF2(vformat, sizeof(vformat), "%% %d.%df", Valwidth,
 			Valprec);
@@ -419,7 +423,7 @@ namespace gmm {
       valcrd = nvalentries/Valperline;
       if ( nvalentries%Valperline != 0) valcrd++;
     } else valcrd = 0;
-
+    
     if ( Nrhs > 0 ) {
       if ( Rhsfmt == NULL ) Rhsfmt = Valfmt;
       ParseRfmt(Rhsfmt,&Rhsperline,&Rhswidth,&Rhsprec, &Rhsflag);
@@ -427,20 +431,22 @@ namespace gmm {
 	SECURE_SPRINTF2(rformat,sizeof(rformat), "%% %d.%df",Rhswidth,Rhsprec);
       else
 	SECURE_SPRINTF2(rformat,sizeof(rformat), "%% %d.%dE",Rhswidth,Rhsprec);
-      //Gmsh fix: this is invalid, as Rhsfmt is a const char*
-      //if (Rhsflag == 'D') *strchr(Rhsfmt,'D') = 'E';
-      rhscrd = nrhsentries/Rhsperline;
+//       if (Valflag == 'D') {
+//         pRhsflag = (char *) strchr(Rhsfmt,'D');
+//         *pRhsflag = 'E';
+//       }
+      rhscrd = nrhsentries/Rhsperline; 
       if ( nrhsentries%Rhsperline != 0) rhscrd++;
       if ( Rhstype[1] == 'G' ) rhscrd+=rhscrd;
       if ( Rhstype[2] == 'X' ) rhscrd+=rhscrd;
       rhscrd*=Nrhs;
     } else rhscrd = 0;
-
+    
     totcrd = 4+ptrcrd+indcrd+valcrd+rhscrd;
-
-
+    
+    
     /*  Print header information:  */
-
+    
     fprintf(out_file,"%-72s%-8s\n%14d%14d%14d%14d%14d\n",Title, Key, totcrd,
 	    ptrcrd, indcrd, valcrd, rhscrd);
     fprintf(out_file,"%3s%11s%14d%14d%14d%14d\n",Type,"          ", M, N, nz, 0);
@@ -452,38 +458,38 @@ namespace gmm {
     }
     else
       fprintf(out_file,"\n");
-
+    
     offset = 1 - shift;  /* if base 0 storage is declared (via macro def), */
     /* then storage entries are offset by 1           */
-
+    
     /*  Print column pointers:   */
     for (i = 0; i < N+1; i++) {
       entry = colptr[i]+offset;
       fprintf(out_file,pformat,entry);
       if ( (i+1)%Ptrperline == 0 ) fprintf(out_file,"\n");
     }
-
+    
     if ( (N+1) % Ptrperline != 0 ) fprintf(out_file,"\n");
-
+    
     /*  Print row indices:       */
     for (i=0;i<nz;i++) {
       entry = rowind[i]+offset;
       fprintf(out_file,iformat,entry);
       if ( (i+1)%Indperline == 0 ) fprintf(out_file,"\n");
     }
-
+    
     if ( nz % Indperline != 0 ) fprintf(out_file,"\n");
-
+    
     /*  Print values:            */
-
+    
     if ( Type[0] != 'P' ) {          /* Skip if pattern only  */
       for (i=0;i<nvalentries;i++) {
 	fprintf(out_file,vformat,val[i]);
 	if ( (i+1)%Valperline == 0 ) fprintf(out_file,"\n");
       }
-
+      
       if ( nvalentries % Valperline != 0 ) fprintf(out_file,"\n");
-
+      
       /*  Print right hand sides:  */
       acount = 1;
       linemod=0;
@@ -524,31 +530,33 @@ namespace gmm {
     GMM_ASSERT1(s == 0, "Error closing file in writeHB_mat_double().");
     return 1;
   }
-
-  template <typename T, int shift> void
+  
+  template <typename T, typename IND_TYPE, int shift> void
   HarwellBoeing_IO::write(const char *filename,
-			  const csc_matrix<T, shift>& A) {
-    write(filename, csc_matrix_ref<T*, unsigned*, unsigned *, shift>
-	  (A.pr, A.ir, A.jc, A.nr, A.nc));
+			  const csc_matrix<T, IND_TYPE, shift>& A) {
+    write(filename, csc_matrix_ref<const T*, const unsigned*,
+	  const unsigned *, shift>
+	  (&A.pr[0], &A.ir[0], &A.jc[0], A.nr, A.nc));
   }
 
-  template <typename T, int shift> void
+  template <typename T, typename IND_TYPE, int shift> void
   HarwellBoeing_IO::write(const char *filename,
-			  const csc_matrix<T, shift>& A,
+			  const csc_matrix<T, IND_TYPE, shift>& A,
 			  const std::vector<T> &rhs) {
-    write(filename, csc_matrix_ref<T*, unsigned*, unsigned *, shift>
-	  (A.pr, A.ir, A.jc, A.nr, A.nc), rhs);
+    write(filename, csc_matrix_ref<const T*, const unsigned*,
+	  const unsigned *, shift>
+	  (&A.pr[0], &A.ir[0], &A.jc[0], A.nr, A.nc), rhs);
   }
 
   template <typename T, typename INDI, typename INDJ, int shift> void
   HarwellBoeing_IO::write(const char *filename,
 			  const csc_matrix_ref<T*, INDI*, INDJ*, shift>& A) {
-    const char *t = 0;
+    const char *t = 0;    
     if (is_complex_double__(T()))
       if (mat_nrows(A) == mat_ncols(A)) t = "CUA"; else t = "CRA";
     else
       if (mat_nrows(A) == mat_ncols(A)) t = "RUA"; else t = "RRA";
-    writeHB_mat_double(filename, mat_nrows(A), mat_ncols(A),
+    writeHB_mat_double(filename, int(mat_nrows(A)), int(mat_ncols(A)),
 		       A.jc[mat_ncols(A)], A.jc, A.ir,
 		       (const double *)A.pr,
 		       0, 0, 0, 0, "GETFEM++ CSC MATRIX", "CSCMAT",
@@ -565,7 +573,7 @@ namespace gmm {
     else
       if (mat_nrows(A) == mat_ncols(A)) t = "RUA"; else t = "RRA";
     int Nrhs = gmm::vect_size(rhs) / mat_nrows(A);
-    writeHB_mat_double(filename, mat_nrows(A), mat_ncols(A),
+    writeHB_mat_double(filename, int(mat_nrows(A)), int(mat_ncols(A)),
 		       A.jc[mat_ncols(A)], A.jc, A.ir,
 		       (const double *)A.pr,
 		       Nrhs, (const double *)(&rhs[0]), 0, 0,
@@ -573,21 +581,21 @@ namespace gmm {
 		       t, 0, 0, 0, 0, "F  ", shift);
   }
 
-
+  
   template <typename MAT> void
   HarwellBoeing_IO::write(const char *filename, const MAT& A) {
-    gmm::csc_matrix<typename gmm::linalg_traits<MAT>::value_type>
+    gmm::csc_matrix<typename gmm::linalg_traits<MAT>::value_type> 
       tmp(gmm::mat_nrows(A), gmm::mat_ncols(A));
-    gmm::copy(A,tmp);
+    gmm::copy(A,tmp); 
     HarwellBoeing_IO::write(filename, tmp);
   }
 
   /** save a "double" or "std::complex<double>" csc matrix into a
       HarwellBoeing file
   */
-  template <typename T, int shift> inline void
+  template <typename T, typename IND_TYPE, int shift> inline void
   Harwell_Boeing_save(const std::string &filename,
-		      const csc_matrix<T, shift>& A)
+		      const csc_matrix<T, IND_TYPE, shift>& A)
   { HarwellBoeing_IO::write(filename.c_str(), A); }
 
   /** save a reference on "double" or "std::complex<double>" csc matrix
@@ -603,9 +611,9 @@ namespace gmm {
   */
   template <typename MAT> inline void
   Harwell_Boeing_save(const std::string &filename, const MAT& A) {
-    gmm::csc_matrix<typename gmm::linalg_traits<MAT>::value_type>
+    gmm::csc_matrix<typename gmm::linalg_traits<MAT>::value_type> 
       tmp(gmm::mat_nrows(A), gmm::mat_ncols(A));
-    gmm::copy(A, tmp);
+    gmm::copy(A, tmp); 
     HarwellBoeing_IO::write(filename.c_str(), tmp);
   }
 
@@ -623,8 +631,8 @@ namespace gmm {
   /** load a "double" or "std::complex<double>" csc matrix from a
       HarwellBoeing file
   */
-  template <typename T, int shift> void
-  Harwell_Boeing_load(const std::string &filename, csc_matrix<T, shift>& A) {
+  template <typename T, typename IND_TYPE, int shift> void
+  Harwell_Boeing_load(const std::string &filename, csc_matrix<T, IND_TYPE, shift>& A) {
     HarwellBoeing_IO h(filename.c_str()); h.read(A);
   }
 
@@ -645,7 +653,7 @@ namespace gmm {
   /*                                                                       */
   /*************************************************************************/
 
-  /*
+  /* 
    *   Matrix Market I/O library for ANSI C
    *
    *   See http://math.nist.gov/MatrixMarket for details.
@@ -662,22 +670,22 @@ namespace gmm {
   /******************* MM_typecode query functions *************************/
 
 #define mm_is_matrix(typecode)	        ((typecode)[0]=='M')
-
+  
 #define mm_is_sparse(typecode)	        ((typecode)[1]=='C')
 #define mm_is_coordinate(typecode)      ((typecode)[1]=='C')
 #define mm_is_dense(typecode)	        ((typecode)[1]=='A')
 #define mm_is_array(typecode)	        ((typecode)[1]=='A')
-
+  
 #define mm_is_complex(typecode)	        ((typecode)[2]=='C')
 #define mm_is_real(typecode)	        ((typecode)[2]=='R')
 #define mm_is_pattern(typecode)	        ((typecode)[2]=='P')
 #define mm_is_integer(typecode)         ((typecode)[2]=='I')
-
+  
 #define mm_is_symmetric(typecode)       ((typecode)[3]=='S')
 #define mm_is_general(typecode)	        ((typecode)[3]=='G')
 #define mm_is_skew(typecode)	        ((typecode)[3]=='K')
 #define mm_is_hermitian(typecode)       ((typecode)[3]=='H')
-
+  
   /******************* MM_typecode modify fucntions ************************/
 
 #define mm_set_matrix(typecode)	        ((*typecode)[0]='M')
@@ -719,7 +727,7 @@ namespace gmm {
 
    MM_matrix_typecode: 4-character sequence
 
-	                object 	    sparse/   	data        storage
+	                object 	    sparse/   	data        storage 
 	                            dense     	type        scheme
 
    string position:	 [0]        [1]		[2]         [3]
@@ -734,7 +742,7 @@ namespace gmm {
 #define MM_MTX_STR	   "matrix"
 #define MM_ARRAY_STR	   "array"
 #define MM_DENSE_STR	   "array"
-#define MM_COORDINATE_STR  "coordinate"
+#define MM_COORDINATE_STR  "coordinate" 
 #define MM_SPARSE_STR	   "coordinate"
 #define MM_COMPLEX_STR	   "complex"
 #define MM_REAL_STR	   "real"
@@ -750,9 +758,9 @@ namespace gmm {
     const char *types[4] = {0,0,0,0};
     /*    int error =0; */
     /*   int i; */
-
+    
     /* check for MTX type */
-    if (mm_is_matrix(matcode))
+    if (mm_is_matrix(matcode)) 
       types[0] = MM_MTX_STR;
     /*
       else
@@ -766,7 +774,7 @@ namespace gmm {
         types[1] = MM_DENSE_STR;
       else
         return NULL;
-
+    
     /* check for element data type */
     if (mm_is_real(matcode))
       types[2] = MM_REAL_STR;
@@ -781,8 +789,8 @@ namespace gmm {
 	    types[2] = MM_INT_STR;
 	  else
 	    return NULL;
-
-
+    
+    
     /* check for symmetry type */
     if (mm_is_general(matcode))
       types[3] = MM_GENERAL_STR;
@@ -794,26 +802,27 @@ namespace gmm {
       types[3] = MM_SKEW_STR;
     else
       return NULL;
-
+    
     SECURE_SPRINTF4(buffer, sizeof(buffer), "%s %s %s %s", types[0], types[1],
 		    types[2], types[3]);
     return SECURE_STRDUP(buffer);
-
+    
   }
-
+  
   inline int mm_read_banner(FILE *f, MM_typecode *matcode) {
     char line[MM_MAX_LINE_LENGTH];
     char banner[MM_MAX_TOKEN_LENGTH];
-    char mtx[MM_MAX_TOKEN_LENGTH];
+    char mtx[MM_MAX_TOKEN_LENGTH]; 
     char crd[MM_MAX_TOKEN_LENGTH];
     char data_type[MM_MAX_TOKEN_LENGTH];
     char storage_scheme[MM_MAX_TOKEN_LENGTH];
     char *p;
+    gmm::standard_locale sl;
     /*    int ret_code; */
-
-    mm_clear_typecode(matcode);
-
-    if (fgets(line, MM_MAX_LINE_LENGTH, f) == NULL)
+    
+    mm_clear_typecode(matcode);  
+    
+    if (fgets(line, MM_MAX_LINE_LENGTH, f) == NULL) 
       return MM_PREMATURE_EOF;
 
 #ifdef GMM_SECURE_CRT
@@ -827,10 +836,10 @@ namespace gmm {
 #endif
       return MM_PREMATURE_EOF;
 
-    for (p=mtx; *p!='\0'; *p=tolower(*p),p++);  /* convert to lower case */
-    for (p=crd; *p!='\0'; *p=tolower(*p),p++);
-    for (p=data_type; *p!='\0'; *p=tolower(*p),p++);
-    for (p=storage_scheme; *p!='\0'; *p=tolower(*p),p++);
+    for (p=mtx; *p!='\0'; *p=char(tolower(*p)),p++) {};  /* convert to lower case */
+    for (p=crd; *p!='\0'; *p=char(tolower(*p)),p++) {};  
+    for (p=data_type; *p!='\0'; *p=char(tolower(*p)),p++) {};
+    for (p=storage_scheme; *p!='\0'; *p=char(tolower(*p)),p++) {};
 
     /* check for banner */
     if (strncmp(banner, MatrixMarketBanner, strlen(MatrixMarketBanner)) != 0)
@@ -853,7 +862,7 @@ namespace gmm {
 	mm_set_dense(matcode);
       else
         return MM_UNSUPPORTED_TYPE;
-
+    
 
     /* third field */
 
@@ -870,7 +879,7 @@ namespace gmm {
 	    mm_set_integer(matcode);
 	  else
 	    return MM_UNSUPPORTED_TYPE;
-
+    
 
     /* fourth field */
 
@@ -887,7 +896,7 @@ namespace gmm {
 	    mm_set_skew(matcode);
 	  else
 	    return MM_UNSUPPORTED_TYPE;
-
+        
     return 0;
   }
 
@@ -895,48 +904,48 @@ namespace gmm {
     char line[MM_MAX_LINE_LENGTH];
     /* int ret_code;*/
     int num_items_read;
-
+    
     /* set return null parameter values, in case we exit with errors */
     *M = *N = *nz = 0;
-
+    
     /* now continue scanning until you reach the end-of-comments */
     do {
-      if (fgets(line,MM_MAX_LINE_LENGTH,f) == NULL)
+      if (fgets(line,MM_MAX_LINE_LENGTH,f) == NULL) 
 	return MM_PREMATURE_EOF;
     } while (line[0] == '%');
-
+    
     /* line[] is either blank or has M,N, nz */
     if (SECURE_NONCHAR_SSCANF(line, "%d %d %d", M, N, nz) == 3) return 0;
     else
-      do {
-	num_items_read = SECURE_NONCHAR_FSCANF(f, "%d %d %d", M, N, nz);
+      do { 
+	num_items_read = SECURE_NONCHAR_FSCANF(f, "%d %d %d", M, N, nz); 
 	if (num_items_read == EOF) return MM_PREMATURE_EOF;
       }
       while (num_items_read != 3);
-
+    
     return 0;
   }
 
 
-  inline int mm_read_mtx_crd_data(FILE *f, int, int, int nz, int I[],
+  inline int mm_read_mtx_crd_data(FILE *f, int, int, int nz, int II[],
 				  int J[], double val[], MM_typecode matcode) {
     int i;
     if (mm_is_complex(matcode)) {
       for (i=0; i<nz; i++)
-	if (SECURE_NONCHAR_FSCANF(f, "%d %d %lg %lg", &I[i], &J[i],
+	if (SECURE_NONCHAR_FSCANF(f, "%d %d %lg %lg", &II[i], &J[i],
 				  &val[2*i], &val[2*i+1])
 	    != 4) return MM_PREMATURE_EOF;
     }
     else if (mm_is_real(matcode)) {
       for (i=0; i<nz; i++) {
-	if (SECURE_NONCHAR_FSCANF(f, "%d %d %lg\n", &I[i], &J[i], &val[i])
+	if (SECURE_NONCHAR_FSCANF(f, "%d %d %lg\n", &II[i], &J[i], &val[i])
 	    != 3) return MM_PREMATURE_EOF;
-
+	
       }
     }
     else if (mm_is_pattern(matcode)) {
       for (i=0; i<nz; i++)
-	if (SECURE_NONCHAR_FSCANF(f, "%d %d", &I[i], &J[i])
+	if (SECURE_NONCHAR_FSCANF(f, "%d %d", &II[i], &J[i])
 	    != 2) return MM_PREMATURE_EOF;
     }
     else return MM_UNSUPPORTED_TYPE;
@@ -945,50 +954,50 @@ namespace gmm {
   }
 
   inline int mm_write_mtx_crd(const char *fname, int M, int N, int nz,
-			      int I[], int J[], const double val[],
+			      int II[], int J[], const double val[],
 			      MM_typecode matcode) {
     FILE *f;
     int i;
-
-    if (strcmp(fname, "stdout") == 0)
+    
+    if (strcmp(fname, "stdout") == 0) 
       f = stdout;
     else {
       SECURE_FOPEN(&f, fname, "w");
       if (f == NULL)
         return MM_COULD_NOT_WRITE_FILE;
     }
-
+    
     /* print banner followed by typecode */
     fprintf(f, "%s ", MatrixMarketBanner);
     char *str = mm_typecode_to_str(matcode);
     fprintf(f, "%s\n", str);
     free(str);
-
+    
     /* print matrix sizes and nonzeros */
     fprintf(f, "%d %d %d\n", M, N, nz);
-
+    
     /* print values */
     if (mm_is_pattern(matcode))
       for (i=0; i<nz; i++)
-	fprintf(f, "%d %d\n", I[i], J[i]);
+	fprintf(f, "%d %d\n", II[i], J[i]);
     else
       if (mm_is_real(matcode))
         for (i=0; i<nz; i++)
-	  fprintf(f, "%d %d %20.16g\n", I[i], J[i], val[i]);
+	  fprintf(f, "%d %d %20.16g\n", II[i], J[i], val[i]);
       else
 	if (mm_is_complex(matcode))
 	  for (i=0; i<nz; i++)
-            fprintf(f, "%d %d %20.16g %20.16g\n", I[i], J[i], val[2*i],
+            fprintf(f, "%d %d %20.16g %20.16g\n", II[i], J[i], val[2*i], 
 		    val[2*i+1]);
 	else {
 	  if (f != stdout) fclose(f);
 	  return MM_UNSUPPORTED_TYPE;
 	}
-
-    if (f !=stdout) fclose(f);
+    
+    if (f !=stdout) fclose(f); 
     return 0;
   }
-
+  
 
   /** matrix input/output for MatrixMarket storage */
   class MatrixMarket_IO {
@@ -1013,13 +1022,13 @@ namespace gmm {
     /* read opened file */
     template <typename Matrix> void read(Matrix &A);
     /* write a matrix */
-    template <typename T, int shift> static void
-    write(const char *filename, const csc_matrix<T, shift>& A);
-    template <typename T, typename INDI, typename INDJ, int shift> static void
+    template <typename T, typename IND_TYPE, int shift> static void 
+    write(const char *filename, const csc_matrix<T, IND_TYPE, shift>& A);  
+    template <typename T, typename INDI, typename INDJ, int shift> static void 
     write(const char *filename,
-	  const csc_matrix_ref<T*, INDI*, INDJ*, shift>& A);
-    template <typename MAT> static void
-    write(const char *filename, const MAT& A);
+	  const csc_matrix_ref<T*, INDI*, INDJ*, shift>& A);  
+    template <typename MAT> static void 
+    write(const char *filename, const MAT& A);  
   };
 
   /** load a matrix-market file */
@@ -1029,8 +1038,8 @@ namespace gmm {
     mm.read(A);
   }
   /** write a matrix-market file */
-  template <typename T, int shift> void
-  MatrixMarket_save(const char *filename, const csc_matrix<T, shift>& A) {
+  template <typename T, typename IND_TYPE, int shift> void
+  MatrixMarket_save(const char *filename, const csc_matrix<T, IND_TYPE, shift>& A) {
     MatrixMarket_IO mm; mm.write(filename, A);
   }
 
